#property copyright "alx1"

extern double Lots               = 0.1;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern int Slippage = 3;
extern bool StopLossMode = True;
extern int StopLoss = 30;
extern bool TakeProfitMode = True;
extern int TakeProfit = 60;
extern bool TrailingStopMode = True;
extern int TrailingStop = 30;
extern int MaxOrders = 3;
extern int barToCheck = 1;
extern int cci = 34;
extern int TRV = 3;

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int ID=167;
int BarCount;
int Current;
bool TickCheck = False;


double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();
   int    losses=0;

   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);

   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }

   if(lot<0.1) lot=0.1;
   return(lot);
  }

int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}

int deinit() {
   return(0);
}

int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   static int dir = 0;


   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;


   
   double TRV240g = iCustom(Symbol(),0,"TRV",240,TRV,0,barToCheck);//green 240
   double TRV240r = iCustom(Symbol(),0,"TRV",240,TRV,1,barToCheck);//red 240
   
   double TRV60g = iCustom(Symbol(),0,"TRV",60,TRV,0,barToCheck);//green 60
   double TRV60r = iCustom(Symbol(),0,"TRV",60,TRV,1,barToCheck);//red 60

   double TRV30g = iCustom(Symbol(),0,"TRV",30,TRV,0,barToCheck);//green 30
   double TRV30r = iCustom(Symbol(),0,"TRV",30,TRV,1,barToCheck);//red 30

   double TRV15g = iCustom(Symbol(),0,"TRV",15,TRV,0,barToCheck);//green 15
   double TRV15r = iCustom(Symbol(),0,"TRV",15,TRV,1,barToCheck);//red 15

   double TRV5g = iCustom(Symbol(),0,"TRV",5,TRV,0,barToCheck);//green 5
   double TRV5r = iCustom(Symbol(),0,"TRV",5,TRV,1,barToCheck);//red 5

   double pTRV240g = iCustom(Symbol(),0,"TRV",240,TRV,0,barToCheck+1);//green 240
   double pTRV240r = iCustom(Symbol(),0,"TRV",240,TRV,1,barToCheck+1);//red 240

   double pTRV60g = iCustom(Symbol(),0,"TRV",60,TRV,0,barToCheck+1);//green 60
   double pTRV60r = iCustom(Symbol(),0,"TRV",60,TRV,1,barToCheck+1);//red 60

   double pTRV30g = iCustom(Symbol(),0,"TRV",30,TRV,0,barToCheck+1);//green 30
   double pTRV30r = iCustom(Symbol(),0,"TRV",30,TRV,1,barToCheck+1);//red 30

   double pTRV15g = iCustom(Symbol(),0,"TRV",15,TRV,0,barToCheck+1);//green 15
   double pTRV15r = iCustom(Symbol(),0,"TRV",15,TRV,1,barToCheck+1);//red 15

   double pTRV5g = iCustom(Symbol(),0,"TRV",5,TRV,0,barToCheck+1);//green 5
   double pTRV5r = iCustom(Symbol(),0,"TRV",5,TRV,1,barToCheck+1);//red 5

   if(dir!=0){
      static int ltime = 0;
      if(ltime!=Bars){
         double cci0 = iCCI(NULL,0,cci,PRICE_CLOSE,barToCheck);
         double cci1 = iCCI(NULL,0,cci,PRICE_CLOSE,barToCheck+1);
         if(dir==1 && cci0>0 && cci1<0){
            ltime=Bars;

            }
         else if(dir==-1 && cci0<0 && cci1>0){
            ltime=Bars;
            } 
         }
      }

//----------------------------------------------------------------------
      if(Bars &&  TRV240g != 0 && TRV60g != 0 && TRV30g != 0 && TRV15g != 0 && TRV5g != 0 || dir==1 && (pTRV240g == 0 || pTRV60g == 0 || pTRV30g == 0 || pTRV15g == 0 || pTRV5g == 0) ) Order = SIGNAL_BUY;
      if(Bars &&  TRV240r != 0 && TRV60r != 0 && TRV30r != 0 && TRV15r != 0 && TRV5r != 0 || dir==-1 && (pTRV240r == 0 || pTRV60r == 0 || pTRV30r == 0 || pTRV15r == 0 || pTRV5r == 0) ) Order = SIGNAL_SELL;
//----------------BUY-CLOSE--------------------

      if (Bars &&  TRV15r != 0 && TRV5r != 0 && (pTRV15r == 0 || pTRV5r == 0) ) Order = SIGNAL_CLOSEBUY;

//----------------SELL-CLOSE--------------------

      if (Bars &&  TRV15g != 0 && TRV5g != 0 && (pTRV15g == 0 || pTRV5g == 0) ) Order = SIGNAL_CLOSESELL;


   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol()==Symbol() && ID==OrderMagicNumber())
     if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close


//+---------------------------Signal End(Exit Buy)

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close


//+-------------Signal End(Exit Sell)

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

//+-----------------------Signal End

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (500 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + ID + ")", ID, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (500 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + ID + ")", ID, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == ID) 
   numords++;
   }
   return(numords);
}  
//+------------------------------------------------------------------+